0000                           ;Synertek Tech Notes Beeper Demo
0001                           ;SET $1000 $3FFF $4000 $4FFF $5000
0002                           ;CLEAR
0003                           ;
0004          .OS              ;Object Store
0005CONFIG    .DE   $89A5      ;Subroutine to setup for beeper
0006PBDA      .DE   $A402      ;Beeper data register
0007PBDDR     .DE   $A403      ;Data direction for beeper
0008TONE      .DE   $10        ;Tone storage
0009LENGTH    .DE   $11        ;How long for each note
0010IRQVEC    .DE   $A67E      ;Place for interrupt Bvector
0011IER1      .DE   $AC0E      ;Register to enable interrupt flag
0012IFR1      .DE   $AC0D      ;Interrupt flag register
0013ACR1      .DE   $AC0B      ;Timer interrupt setup register
0014T1LL1     .DE   $AC06      ;Address of low timer
0015T1CH1     .DE   $AC05      ;Address of high timer
0016ACCESS    .DE   $8B86      ;Subroutine to enable RAM
0017                           ;
0018                           ;
0019                           ;
0020START     SEI              ;Disable all interrupts
0021                           ;
0022          JSR   ACCESS     ;Enable system RAM
0023                           ;
0024          LDA   #L,INTRPT  ;Setup interrupt address
0025          STA   IRQVEC     ;at the location in
0026          LDA   #H,INTRPT  ;memory to cause the interrupt
0027          STA   IRQVEC+1   ;to branch to our interrupt subroutine
0028                           ;
0029                           ;
0030          LDA   #$0F       ;Setup data direction flag
0031          STA   PBDDR      ;
0032                           ;
0033          LDA   #$FF       ;Initialize the tone
0034          STA   TONE       ;
0035                           ;
0036          LDA   #$01       ;Initialize tone length
0037          STA   LENGTH     ;
0038                           ;
0039          LDA   #$40       ;Setup interrupt timer
0040          STA   ACR1       ;without having square waves
0041                           ;
0042          LDA   #$C0       ;Enable the interrupt flag
0043          STA   IER1       ;
0044                           ;
0045          LDA   #$40       ;Clear any pending flags
0046          STA   IFR1       ;if they are there
0047                           ;
0048          LDA   #$20       ;Start the interrupt timers
0049          STA   T1LL1      ;
0050          STA   T1CH1      ;
0051                           ;
0052BEEPER    LDA   #$0D       ;Configure for the beeper
0053          JSR   CONFIG     ;
0054                           ;
0055          CLI              ;Enable the interrupts and start!
0056                           ;
0057BE1       LDA   #$08       ;Turn beeper on
0058          STA   PBDA       ;
0059          JSR   BE2        ;Wait awhile
0060          LDA   #$06       ;Turn beeper off
0061          STA   PBDA       ;
0062          JSR   BE2        ;Wait awhile
0063          BCC   BE1        ;Do it again
0064                           ;
0065BE2       LDY   TONE       ;Delay subroutine
0066BE3       DEY              ;Decrement
0067          BNE   BE3        ;until zero
0068                           ;
0069          RTS              ;Return from subroutine
0070                           ;
0071                           ;
0072                           ;
0073INTRPT    PHA              ;Save the accumulator
0074          TYA              ;Transfer Y register to accumulator
0075          PHA              ;Save that too
0076                           ;
0077          LDA   #$40       ;Clear the pending interrupt flag
0078          STA   IFR1       ;
0079                           ;
0080          DEC   LENGTH     ;Decrement each note length
0081          BNE   RETURN     ;and go back until zero
0082                           ;
0083          LDA   #$01       ;Restore length register
0084          STA   LENGTH     ;
0085                           ;
0086          DEC   TONE       ;Set note higher
0087          LDA   TONE       ;is it high enough?
0088          CMP   #$10       ;10 is the limit
0089          BCS   RETURN     ;if not 10, return
0090                           ;
0091          LDA   #$FF       ;Set to lowest note
0092          STA   TONE       ;
0093                           ;
0094RETURN    PLA              ;Replace everything
0095          TYA              ;Y register is back
0096          PLA              ;Accumulator is back
0097                           ;
0098          RTI              ;Return from interrupt
0099                           ;
9999          .EN              ;
